mixin input(type, name, placeholder, required)
	if required
		input.form-control(
			type=type,
			name=name,
			placeholder=placeholder,
			required=required,
			aria-required="true"
		)&attributes(attributes)
	else
		input.form-control(
			type=type,
			name=name,
			placeholder=placeholder
		)&attributes(attributes)
mixin input-value(type, name, placeholder, value, required)
	if required
		input.form-control(
			type=type,
			name=name,
			placeholder=placeholder,
			value=value,
			required=required,
			aria-required="true"
		)&attributes(attributes)
	else
		input.form-control(
			type=type,
			name=name,
			placeholder=placeholder,
			value=value
		)&attributes(attributes)
mixin input-lg(type, name, placeholder, required)
	if required
		input.form-control.form-control-lg(
			type=type,
			name=name,
			placeholder=placeholder,
			required=required,
			aria-required="true"
		)&attributes(attributes)
	else
		input.form-control.form-control-lg(
			type=type,
			name=name,
			placeholder=placeholder
		)&attributes(attributes)
mixin input-lg-value(type, name, placeholder, value, required)
	if required
		input.form-control.form-control-lg(
			type=type,
			name=name,
			placeholder=placeholder,
			value=value,
			required=required,
			aria-required="true"
		)&attributes(attributes)
	else
		input.form-control.form-control-lg(
			type=type,
			name=name,
			placeholder=placeholder,
			value=value
		)&attributes(attributes)
//-
mixin input-tt(type, name, placeholder, required)
	if required
		.input-group
			input.form-control(
				type=type,
				name=name,
				placeholder=placeholder,
				required=required,
				aria-required="true"
			)&attributes(attributes)
	else
		.input-group
			input.form-control(
				type=type,
				name=name,
				placeholder=placeholder
			)&attributes(attributes)
mixin input-tt-value(type, name, placeholder, value, required)
	if required
		.input-group
			input.form-control(
				type=type,
				name=name,
				placeholder=placeholder,
				value=value,
				required=required,
				aria-required="true"
			)&attributes(attributes)
	else
		.input-group
			input.form-control(
				type=type,
				name=name,
				placeholder=placeholder,
				value=value
			)&attributes(attributes)
mixin input-tt-lg(type, name, placeholder, required)
	if required
		.input-group
			input.form-control.form-control-lg(
				type=type,
				name=name,
				placeholder=placeholder,
				required=required,
				aria-required="true"
			)&attributes(attributes)
	else
		.input-group
			input.form-control.form-control-lg(
				type=type,
				name=name,
				placeholder=placeholder
			)&attributes(attributes)
mixin input-tt-lg-value(type, name, placeholder, value, required)
	if required
		.input-group
			input.form-control.form-control-lg(
				type=type,
				name=name,
				placeholder=placeholder,
				value=value,
				required=required,
				aria-required="true"
			)&attributes(attributes)
	else
		.input-group
			input.form-control.form-control-lg(
				type=type,
				name=name,
				placeholder=placeholder,
				value=value
			)&attributes(attributes)
//-
mixin input-group(type, name, placeholder, required)
	if required
		.input-group
			input.form-control(
				type=type,
				name=name,
				placeholder=placeholder,
				required=required,
				aria-required="true"
			)&attributes(attributes)
	else
		.input-group
			input.form-control(
				type=type,
				name=name,
				placeholder=placeholder
			)&attributes(attributes)
mixin input-group-value(type, name, placeholder, value, required)
	if required
		.input-group
			input.form-control(
				type=type,
				name=name,
				placeholder=placeholder,
				value=value,
				required=required,
				aria-required="true"
			)&attributes(attributes)
	else
		.input-group
			input.form-control(
				type=type,
				name=name,
				placeholder=placeholder,
				value=value
			)&attributes(attributes)
mixin input-group-lg(type, name, placeholder, fa, required)
	if required
		.input-group.input-group--fa
			input.form-control.form-control-lg(
				type=type,
				name=name,
				placeholder=placeholder,
				required=required,
				aria-required="true"
			)&attributes(attributes)
			i(class=fa)
	else
		.input-group.input-group--fa
			input.form-control.form-control-lg(
				type=type,
				name=name,
				placeholder=placeholder
			)&attributes(attributes)
			i(class=fa)
mixin input-group-lg-value(type, name, placeholder, value, required)
	if required
		.input-group
			input.form-control.form-control-lg(
				type=type,
				name=name,
				placeholder=placeholder,
				value=value,
				required=required,
				aria-required="true"
			)&attributes(attributes)
	else
		.input-group
			input.form-control.form-control-lg(
				type=type,
				name=name,
				placeholder=placeholder,
				value=value
			)&attributes(attributes)
//-
mixin input-label(type, name, label, placeholder, required)
	if required
		label.db
			span= label
			.input-group
				input.form-control(
					type=type,
					name=name,
					placeholder=placeholder,
					required=required,
					aria-required="true"
				)&attributes(attributes)
	else
		label.db
			span= label
			.input-group
				input.form-control(
					type=type,
					name=name,
					placeholder=placeholder
				)&attributes(attributes)
mixin input-label-lg(type, name, label, placeholder, required)
	if required
		label.db
			span= label
			.input-group
				input.form-control.form-control-lg(
					type=type,
					name=name,
					placeholder=placeholder,
					required=required,
					aria-required="true"
				)&attributes(attributes)
	else
		label.db
			span= label
			.input-group
				input.form-control.form-control-lg(
					type=type,
					name=name,
					placeholder=placeholder
				)&attributes(attributes)
//-
mixin input-label-group(type, name, label, placeholder, required)
	if required
		label.db
			span= label
			.input-group
				input.form-control(
					type=type,
					name=name,
					placeholder=placeholder,
					required=required,
					aria-required="true"
				)&attributes(attributes)
	else
		label.db
			span= label
			.input-group
				input.form-control(
					type=type,
					name=name,
					placeholder=placeholder
				)&attributes(attributes)
mixin input-label-group-value(type, name, label, placeholder, value, required)
	if required
		label.db
			span= label
			.input-group
				input.form-control(
					type=type,
					name=name,
					placeholder=placeholder,
					value=value,
					required=required,
					aria-required="true"
				)&attributes(attributes)
	else
		label.db
			span= label
			.input-group
				input.form-control(
					type=type,
					name=name,
					placeholder=placeholder,
					value=value
				)&attributes(attributes)
mixin input-label-group-xl(type, name, label, placeholder, fa, required)
	if required
		label.db
			span= label
			.input-group.input-group--fa
				input.form-control.form-control-xl(
					type=type,
					name=name,
					placeholder=placeholder,
					required=required,
					aria-required="true"
				)&attributes(attributes)
				i(class=fa)
	else
		label.db
			span= label
			.input-group.input-group--fa
				input.form-control.form-control-xl(
					type=type,
					name=name,
					placeholder=placeholder
				)&attributes(attributes)
				i(class=fa)
mixin input-nolabel-group-xl(type, name, placeholder, fa, required)
	if required
		.input-group.input-group--fa
			input.form-control.form-control-xl(
				type=type,
				name=name,
				placeholder=placeholder,
				required=required,
				aria-required="true"
			)&attributes(attributes)
			i(class=fa)
	else
		label.db
			span= label
			.input-group.input-group--fa
				input.form-control.form-control-xl(
					type=type,
					name=name,
					placeholder=placeholder
				)&attributes(attributes)
				i(class=fa)
mixin input-label-group-lg(type, name, label, placeholder, fa, required)
	if required
		label.db
			span= label
			.input-group.input-group--fa
				input.form-control.form-control-lg(
					type=type,
					name=name,
					placeholder=placeholder,
					required=required,
					aria-required="true"
				)&attributes(attributes)
				i(class=fa)
	else
		label.db
			span= label
			.input-group.input-group--fa
				input.form-control.form-control-lg(
					type=type,
					name=name,
					placeholder=placeholder
				)&attributes(attributes)
				i(class=fa)
mixin input-label-group-lg-value(type, name, label, placeholder, value, required)
	if required
		label.db
			span= label
			.input-group
				input.form-control.form-control-lg(
					type=type,
					name=name,
					placeholder=placeholder,
					value=value,
					required=required,
					aria-required="true"
				)&attributes(attributes)
	else
		label.db
			span= label
			.input-group
				input.form-control.form-control-lg(
					type=type,
					name=name,
					placeholder=placeholder,
					value=value
				)&attributes(attributes)